String Message;  // Declare a string variable to store incoming serial messages

void setup() {
  Serial.begin(9600);  // Initialize serial communication at 9600 baud
  Serial.setTimeout(50);  // Set the timeout for reading serial data to 50 milliseconds (default is 1 second)
  delay(100);  // Delay for stability
  pinMode(3, OUTPUT);  // Set digital pin 3 as an output
}  // setup

void loop() {
  // put your main code here, to run repeatedly:

  if (Serial.available()) {
    Message = Serial.readString();  // Read the incoming serial message and store it in the 'Message' variable
  }

  delay(4);  // Introduce a small delay to avoid continuous checking and improve performance

  if (Message == "on") {
    digitalWrite(3, HIGH);  // If the received message is "on", set digital pin 3 to HIGH
  }

  if (Message == "off") {
    digitalWrite(3, LOW);  // If the received message is "off", set digital pin 3 to LOW
  }
  // Message = "\0";  // Uncomment if you want to reset the Message variable after each loop iteration
}  // loop
